var youtube = {
  run: function(win, doc){
    SaveFrom.setBrowserData(win, 'youtube', '');

    var winObj = win.wrappedJSObject;

    var swfargs = null;
    var token = '';
    var video_id = '';

    var channel = false;
    var changingTimeout = 0;
    var panelId = 'savefrom__yt_links';
    var buttonId = 'savefrom__yt_btn';

    var panelParent = null;
    var panelInsertBefore = null;

    var newInterface = false;

    init();


    function init()
    {
      if(win.location.href.search(/youtube\.com\/user\//i) > -1)
        channel = true;

      if(!isVideoPage())
        return;

      if(channel)
      {
        var e = doc.getElementById('playnav-navbar');
        if(e)
        {
          var btnParent = e;

          e = doc.getElementById('playnav-channel-header');
          if(e)
          {
            panelParent = e.parentNode;
            panelInsertBefore = SaveFrom.utils.nextSibling(e);
            appendDownloadButton(btnParent);
          }
        }
      }
      else
      {
        var p = doc.getElementById('watch-headline-user-info');
        if(!p)
        {
          p = doc.getElementById('watch-bar-switcher');
          if(p)
            newInterface = true;
        }

        if(!p)
        {
          var e = doc.getElementById('watch-video-count');
          if(!e)
            e = doc.getElementById('editSubscriptionDiv');

          if(e)
            p = e.parentNode;
        }

        if(p)
        {
          panelParent = p.parentNode.parentNode;
          panelInsertBefore = SaveFrom.utils.nextSibling(p.parentNode);
          appendDownloadButton(p);
        }
      }
    }


    function isVideoPage()
    {
      swfargs = getSwfArgs();
      if(!swfargs)
        return false;

      var t = swfargs.t ? swfargs.t : swfargs.token;
      if(!t || (token && token == t))
        return false;

      token = t;

      video_id = swfargs.video_id;
      if(!video_id)
      {
        var m = win.location.href.match(/\/watch\?(?:.+&)?v=([\w\-]+)/i);
        if(m && m.length > 1)
          video_id = m[1];
      }

      if(!video_id)
        return false;

      return true;
    }


    function togglePanel(event)
    {
      var e = doc.getElementById(panelId);
      if(!e)
      {
        getLinks();
        return;
      }

      if(e.style.display == 'none')
        e.style.display = '';
      else
        e.style.display = 'none';
    }


    function appendDownloadButton(parent)
    {
      if(doc.getElementById(buttonId))
        return false;

      if(channel)
      {
        var tr = parent.querySelector('tr');
        if(tr)
        {
          var td = doc.createElement('td');

          var b = doc.createElement('a');
          b.href = 'javascript:;';
          b.id = buttonId;
          b.className = 'navbar-tab inner-box-link-color';
          b.textContent = SaveFrom.lng('module.download');
          b.addEventListener('click', togglePanel, false);

          td.appendChild(b);
          tr.appendChild(td);
        }
      }
      else
      {
        var b = doc.createElement('button');
        b.className = newInterface ? 'yt-uix-button yt-uix-button-dark' :
          'yt-uix-button yt-uix-button-default';
        b.id = buttonId;
        b.addEventListener('click', togglePanel, false);
        b.style.marginLeft = '10px';

        var s = doc.createElement('span');
        s.className = 'yt-uix-button-content';
        s.textContent = SaveFrom.lng('module.download');
        if(!newInterface)
        {
          s.style.color = '#000';
          s.style.fontWeight = 'bold';
        }
        b.appendChild(s);

        parent.appendChild(b);
      }
      return true;
    }


    function catchVideoChanging(event)
    {
      clearTimeout(changingTimeout);
      changingTimeout = setTimeout(function(){
        var p = doc.getElementById(panelId);
        if(p)
          p.parentNode.removeChild(p);

        init();
      }, 1000);
    }


    function getTitle()
    {
      if(channel)
      {
        var t = doc.getElementById('playnav-curvideo-title');
        if(t)
          return t.textContent;
      }

      var t = doc.getElementById('watch-headline-title');
      if(t)
        return t.textContent;

      var meta = doc.getElementsByTagName('meta');
      for(var i = 0; i < meta.length; i++)
      {
        var name = meta[i].getAttribute('name', false);
        if(name && name.toLowerCase() == 'title')
          return meta[i].getAttribute('content', false);
      }

      return '';
    }


    function getSwfArgs()
    {
      if(!channel)
      {
        if(winObj.yt && winObj.yt.config_)
        {
          if(winObj.yt.config_['SWF_CONFIG'] && winObj.yt.config_['SWF_CONFIG'].args)
            return winObj.yt.config_['SWF_CONFIG'].args;
          else if(winObj.yt.config_['PLAYER_CONFIG'] && winObj.yt.config_['PLAYER_CONFIG'].args)
            return winObj.yt.config_['PLAYER_CONFIG'].args;
        }

        var t = doc.body.innerHTML.match(/[\"\']args[\"\']\s*:\s*(\{[^\}]+\})/i);
        if(t && t.length > 1 && SaveFrom.JSON)
        {
          return SaveFrom.JSON.parse(t[1]);
        }
      }


      var e = doc.getElementsByTagName('embed');
      for(var i = 0; i < e.length; i++)
      {
        var f = e[i].getAttribute('flashvars', false);
        if(f && f.search(/fmt_map=/i) != -1)
        {
          var swfargs = [];
          f = f.split('&');
          for(var j = 0; j < f.length; j++)
          {
            var p = f[j].split('=', 2);
            if(p.length == 2)
              swfargs[p[0]] = p[1];
            else if(p.length == 1)
              swfargs[p[0]] = '';
          }

          var p = e[i].parentNode;
          p.removeEventListener('DOMNodeInserted', catchVideoChanging, false);
          p.addEventListener('DOMNodeInserted', catchVideoChanging, false);
          var e = doc.getElementById('channel-body');
          if(e)
            e.removeEventListener('DOMNodeInserted', catchVideoChanging, false);

          return swfargs;
        }
      }

      if(channel)
      {
        var e = doc.getElementById('channel-body');
        if(e)
        {
          e.removeEventListener('DOMNodeInserted', catchVideoChanging, false);
          e.addEventListener('DOMNodeInserted', catchVideoChanging, false);
        }
      }

      return null;
    }


    function getDownloadLink(video_id, token, fmt)
    {
      return 'http://' + winObj.location.host + '/get_video?video_id=' + video_id + '&t=' + token + '&fmt=' + fmt + '&asv=';
    }


    function showLinks(l)
    {
      var title = getTitle(), titleAttr = '';
      if(title)
      {
        title = SaveFrom.utils.modifyTitle(title);
        titleAttr = '&title=' + encodeURIComponent(title);
      }

      var box = doc.getElementById(panelId);
      if(box)
        box.parentNode.removeChild(box);

      box = doc.createElement('div');
      box.id = panelId;
      if(channel)
      {
        box.className = 'inner-box-bg-color';
      }
      else
      {
        if(newInterface)
         box.className = 'yt-bar';
        else
        {
          box.className = 'yt-rounded';
          box.style.backgroundColor = '#f3f3f3';
        }
      }

      SaveFrom.utils.setStyle(box, {
        textAlign: 'center',
        fontSize: '15px',
        fontWeight: 'bold',
        padding: newInterface ? '5px 10px' : '3px 10px',
        margin: '5px 0'
      });

      var aStyle = {
        whiteSpace: 'nowrap'
      };

      if(newInterface)
        aStyle.color = '#fff';

      var sStyle = {
        fontSize: '75%',
        fontWeight: 'normal',
        marginLeft: '3px',
        whiteSpace: 'nowrap'
      };

      for(var i in l)
        l[i] += titleAttr;

      SaveFrom.video.yt.show(SaveFrom, l, box,
        {link: aStyle, text: sStyle, btn: null, fsIcon: {opacity: '.5'}, fsText: null});

      if(panelParent)
      {
        if(panelInsertBefore)
          panelParent.insertBefore(box, panelInsertBefore);
        else
          panelParent.appendChild(box);
      }
    }


    function getLinks()
    {
      if(!swfargs || !token || !video_id)
        return false;

      var u = swfargs['fmt_url_map'];
      if(!u)
        u = swfargs['url_encoded_fmt_stream_map'];

      if(!u)
        return false;

      var mp4 = false;

      var l = {};

      if(u.search(/url=http/i) > -1)
      {
        u = u.replace(/\\u0026/ig, '&').replace(/\\\//g, '/');
        u = u.replace(/^url=/i, '').replace(/,\w+=/ig, '\n');
        u = u.split('\n');
        if(u && u.length > 0)
        {
          for(var i = 0; i < u.length; i++)
          {
            u[i] = u[i].replace(/^.*url=http/i, 'http');
            
            if(u[i].search(/^https?%3a/i) > -1)
              u[i] = decodeURIComponent(u[i]);

            var fmt = u[i].match(/(?:\?|&)itag=(\d+)/i)
            {
              if(fmt && fmt.length > 1)
              {
                u[i] = u[i].replace(/(?:\?|&)(?:type|fallback_host)=[^&]+/ig, '').
                  replace(/(\?|&)sig=/i, '$1signature=');
                  
                l[fmt[1]] = u[i].replace(/((?:\?|&)itag=\d+.*)&itag=\d+/ig, '$1');

                if(fmt == '18')
                  mp4 = true;
              }
            }
          }
        }
      }
      else
      {
        u = decodeURIComponent(u);
        u = u.replace(/\\u0026/ig, '&').replace(/\\\//g, '/');
        u = u.replace(/,(\d+)\|/g, "\n$1|");
        u = u.split('\n');
        if(u && u.length > 0)
        {
          for(var i = 0; i < u.length; i++)
          {
            var t = u[i].split('|');
            if(t && t.length == 2)
            {
              l[t[0]] = t[1];
              if(t[0] == '18')
                mp4 = true;
            }
          }
        }
      }

      // if(l['5'] && l['34']) delete l['5'];

      showLinks(l);

      if(!mp4)
      {
        try
        {
          SaveFrom.request.send(getDownloadLink(video_id, token, '18'), function(r){
            if(r.status < 400)
            {
              var loc = r.getResponseHeader('Location');
              if(loc && loc.search(/\/videoplayback\?/i) != -1)
                l['18'] = loc;
              else
                l['18'] = getDownloadLink(video_id, token, '18');

              showLinks(l);
            }
          }, 'HEAD');
        }
        catch(err){}
      }

      return true;
    }
  }
};